// ZKWindow.h

#include <Window.h>
#include <MenuBar.h>
#include <Bitmap.h>
#include <Menu.h>
#include <MenuItem.h>

#include "ZKDefs.h"
#include "IconMenu.h"
#include "EditView.h"

#ifndef __ZOO_WINDOW_H__
#define __ZOO_WINDOW_H__

class ZKWindow : public BWindow
{
public:
					ZKWindow			(BRect a_winframe);
					~ZKWindow			();
	virtual void	MessageReceived 	(BMessage * a_message);
	virtual bool	QuitRequested		();
			
private:
			status_t	MakeSettingsFolder	(void);
			status_t	ReadSettings		(void);
			status_t	SaveSettings		(void);
			void		FileDropped			(BMessage * a_message);	
			void		DoneEditing			(void);
			
	BBox		*	topbox;

	BBox		*	m_dropbox;
	EditView	*	m_editbox;
	
	BMenuBar	*	m_menubar;
	IconMenu	*	m_iconmenu;
	BBitmap		*	m_bitmap;
	
	BMenu		*	m_appmenu;

	BMenuItem	*	m_aboutitem;
	BMenuItem	*	m_quititem;
	BMenuItem	*	m_help_item;
	
};

#endif

