// ZooKeeper, by Jonas.Sundstrom
// © Kirilla.com -- see Kirilla Sample Code License

#define DEBUG 0
#include <Debug.h>

#include <Application.h>
#include <Roster.h>
#include <String.h>

#include <be/kernel/fs_attr.h> 

#include <stdio.h>
#include <unistd.h>
#include <errno.h>

#include "ZKApp.h" 

int main(int argc, char *argv[], char *arge[]) 
{
	// load app signature from attribute
	BString	app_sig			=	"application/x-vnd.kirilla-zookeeper"; // default, fallback MIME
	BString	tmp_string		=	"";
	
	DIR *	 	dir			=	NULL;
	dirent_t *	dirent		=	NULL;
	attr_info	att_info;
	int 		fd			=	0;
	char *		buffer		=	NULL;
	ssize_t		bytes		=	0;
	
	dir = fs_open_attr_dir(argv[0]);
	
	if (dir != NULL)
	{
		while((dirent = fs_read_attr_dir(dir)))
		{
			tmp_string	=	dirent->d_name;
			//PRINT(("attr: %s\n", tmp_string.String()));
			
			if (tmp_string == "BEOS:APP_SIG")
			{
				fd = open(argv[0], O_RDONLY);
			
				fs_stat_attr(fd, dirent->d_name, &att_info);
				buffer = new char [att_info.size];
				bytes = fs_read_attr(fd, dirent->d_name, att_info.type, 0, buffer, att_info.size);

				if (bytes > 0 && bytes == att_info.size)
				{ 
					buffer[att_info.size] = '\0';
					app_sig	=	buffer;
					break;
				}
			}	
		}
		
		close(fd);
		fs_close_attr_dir(dir);		
	}
	delete [] buffer;

	PRINT(("Signature: %s\n", app_sig.String()));

	new ZooKeeperApp(app_sig.String());
	be_app-> Run();
	
	delete	be_app;	
	return	(0);
}

